// デモ 風船を飛ばす
// STARTボタンを押すと終了します

// イメージデータについて
// http://www.picosoft.co.jp/ORANGE-light/image1616.html
// Copyright (c) 2019 Picosoft Co., Ltd.
// Made by Kaori Hanatsumi

' 色定数の定義
DARKRED = rgb(64, 12, 0)
BLUE = rgb(0, 0, 255)

' ボタンの定義
BUTTON_START = 9

' スプライトパターン定義
IMG_FU03 = getmptr()
mdata 0x00, 0x00, 0x00, 0x00, 0x01, 0xC0, 0x03, 0x20, 0x07, 0x90, 0x07, 0xD0, 0x07, 0xF0, 0x07, 0xF0, 0x03, 0xE0, 0x01, 0xC0, 0x00, 0x80, 0x00, 0x80, 0x01, 0x00, 0x06, 0x00, 0x38, 0x00, 0x00, 0x00
IMG_FU02 = getmptr()
mdata 0x00, 0x00, 0x01, 0xC0, 0x03, 0x20, 0x07, 0x90, 0x07, 0xD0, 0x07, 0xF0, 0x07, 0xF0, 0x03, 0xE0, 0x01, 0xC0, 0x00, 0x80, 0x00, 0x80, 0x01, 0x00, 0x02, 0x00, 0x02, 0x00, 0x02, 0x00, 0x00, 0x00
IMG_FU01 = getmptr()
mdata 0x00, 0x00, 0x01, 0xC0, 0x03, 0x20, 0x07, 0x90, 0x07, 0xD0, 0x07, 0xF0, 0x07, 0xF0, 0x03, 0xE0, 0x01, 0xC0, 0x00, 0x80, 0x00, 0x80, 0x00, 0x80, 0x00, 0x80, 0x00, 0x80, 0x00, 0x80, 0x00, 0x00
IMG_FU04 = getmptr()
mdata 0x00, 0x00, 0x03, 0x80, 0x06, 0x40, 0x0F, 0x20, 0x0F, 0xA0, 0x0F, 0xE0, 0x0F, 0xE0, 0x07, 0xC0, 0x03, 0x80, 0x01, 0x00, 0x01, 0x00, 0x00, 0x80, 0x00, 0x40, 0x00, 0x40, 0x00, 0x40, 0x00, 0x00
IMG_FU05 = getmptr()
mdata 0x00, 0x00, 0x00, 0x00, 0x03, 0x80, 0x06, 0x40, 0x0F, 0x20, 0x0F, 0xA0, 0x0F, 0xE0, 0x0F, 0xE0, 0x07, 0xC0, 0x03, 0x80, 0x01, 0x00, 0x01, 0x00, 0x00, 0x80, 0x00, 0x60, 0x00, 0x1C, 0x00, 0x00

N=15

' 配列変数 定義
SP = getmptr()
mptr SP + 10*N
// struct
// +0:x
// +2:y  (F10.6)
// +4:sy (F10.6)
// +6:col(RGB565)
// +8:image No.

' 構造体 初期化
for i=0 to N-1
	sp_x_set(i,20 + i*(300/N))
	sp_y_set(i,204<<6)
	sp_sy_set(i,-(8+rnd(56)))
	sp_col_set(i,rnd(-1))
	sp_img_set(i,0)
next

' 初期画面 描画
rect 0,0,320,232,BLUE,1
rect 0,232,320,8,DARKRED,1

' 山を書く
c=0xE4
for x=0 to 39
	c = c + rnd(3)-1
	c = c + (c < 0xE0) - (c > 0xE7)
	gprint x*8,224,chr$(c),DARKRED,BLUE
next

' メインループ
while in(BUTTON_START)
	for i=0 to N-1
		move_fusen(i)
	next
	pause 10
wend
end

def move_fusen(n) {
	var x
	var y
	var d
	var img
	d = rnd(3) -1
	x = sp_x(n) + d
	x = x + (x<20) - (x>304)
	sp_x_set(n,x)

	if !rnd(10) then img = sp_img(n) + d: img = img + (img<-2) - (img>2) :sp_img_set(n,img)

	y = sp_y(n) + sp_sy(n)
	if y<0 then rect x,0,16,16,BLUE,1:y=204<<6:sp_col_set(n,rnd(-1))
	sp_y_set(n,y)

	sprnew(0,sp_x(n),sp_y(n)>>6,16,16,IMG_FU01 + sp_img(n)*32,sp_col(n),BLUE)
	sprdsp 0,1
}

' 構造体アクセス関数
def sp_x(i) {
	return mpeekw(SP/2 + i*5)
}
def sp_y(i) {
	return mpeekw(SP/2 + i*5 +1)
}
def sp_sy(i) {
	return mpeekw(SP/2 + i*5 +2)
}
def sp_col(i) {
	return mpeekw(SP/2 + i*5 +3)
}
def sp_img(i) {
	return mpeekw(SP/2 + i*5 +4)
}
def sp_x_set(i,n) {
	mpokew SP/2 + i*5,n
}
def sp_y_set(i,n) {
	mpokew SP/2 + i*5 +1,n
}
def sp_sy_set(i,n) {
	mpokew SP/2 + i*5 +2,n
}
def sp_col_set(i,n) {
	mpokew SP/2 + i*5 +3,n
}
def sp_img_set(i,n) {
	mpokew SP/2 + i*5 +4,n
}

